<script lang="ts">
	import axios from "axios"
	import queryString from "query-string"
	import { getContext } from "svelte"
	import { browser } from "$app/env"
	import { goto } from "$app/navigation"
	import { page, session } from "$app/stores"
	import type { DataPackage, Project } from "$lib/storage"
	import { userProfile } from "$lib/stores"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"
	import ContributeToDataPackageForm from "$lib/components/ContributeToDataPackageForm.svelte"
	import MultilineLoadIndicator from "$lib/components/MultilineLoadIndicator.svelte"
	import { filesToReadenFiles } from "$lib/utils/file"

	$: project = $page.query.get("project")

	let dataPackage: DataPackage = null
	let fetchError
	let storageAdapter
	let selectedProject: Project | null = null
	let filteredFiles: Array<string> = []
	let previousFiles: Array<string> = []
	let removedFiles: Array<string> = []

	let comment: string | null = null
	let email: string | null = null

	let isAnonymous: boolean = true
	let mergeRequestUrl: string | null = null

	const { tokens } = getContext(AUTH_CONTEXT_KEY)
	$: if (browser) {
		if (!$tokens) {
			fetchInitialDataAsAnonymous($session)
		} else if ($tokens && $userProfile) {
			fetchInitialData($session, $tokens, $userProfile)
			isAnonymous = false
		}
	}

	async function fetchInitialData(session, tokens, userProfile) {
		const GitLabStorageAdapter = (await import("$lib/infrastructure/storage-adapter/gitlab")).default
		storageAdapter = GitLabStorageAdapter.create(session.config, tokens, userProfile)
		// Fetch data package to view
		if (project) {
			try {
				dataPackage = await storageAdapter.fetchDataPackage(project)
				filteredFiles = dataPackage.resources.map((resource) => resource.path).filter(Boolean)
				previousFiles = [...filteredFiles]
				selectedProject = await storageAdapter.fetchProject(project)
			} catch (error) {
				console.error(error)
				fetchError = "Could not load data package"
			}
		} else {
			fetchError = "Query string parameter 'project' is missing."
		}
	}

	async function fetchInitialDataAsAnonymous(session) {
		try {
			const response = await axios.get("/api/data-packages/fetch-initial-data", {
				params: {
					project: project,
				},
			})
			dataPackage = response.data.dataPackage
			filteredFiles = dataPackage.resources.map((resource) => resource.path).filter(Boolean)
			previousFiles = [...filteredFiles]
			selectedProject = response.data.selectedProject
		} catch (error) {
			console.error(error)
			fetchError = "Could not load data package"
		}
	}

	async function handleSubmit(event) {
		if (selectedProject === null || storageAdapter === null) {
			return
		}
		const formData = event.detail
		let contributionSent
		try {
			if (!isAnonymous) {
				contributionSent = await storageAdapter.contributeToDataPackage(
					selectedProject,
					formData,
					filteredFiles,
					previousFiles,
					removedFiles
				)
			} else {
				const contributionComment: string = formData.get("contribution-comment") as string
				const email: string = formData.get("contribution-email") as string
				const formDataFiles: Array<File> = formData.getAll("datapackage-resource") as Array<File>
				const files = await filesToReadenFiles(formDataFiles)
				const projectName = project
				contributionSent = await axios.post("/api/data-packages/contribute", {
					projectName,
					filteredFiles,
					previousFiles,
					removedFiles,
					contributionComment,
					files,
					email,
				})
			}
		} catch (error) {
			console.error(error)
			fetchError = "Could not send contribution to data package"
		}
		if (contributionSent.data) {
			if (contributionSent.data.error) {
				fetchError = contributionSent.data.error
			} else if (contributionSent.data.mergeRequestUrl) {
				mergeRequestUrl = contributionSent.data.mergeRequestUrl
			}
		}
	}
</script>

{#if fetchError}
	<p>{fetchError}</p>
{:else if selectedProject}
	{#if !mergeRequestUrl}
		Contribute to : <a href={selectedProject.url} rel="external" target="_blank">{selectedProject.name}</a>
		{#if dataPackage}
			<ContributeToDataPackageForm
				{comment}
				{email}
				{isAnonymous}
				bind:filteredFiles
				{previousFiles}
				bind:removedFiles
				on:submit={handleSubmit}
			/>
		{/if}
	{:else}
		<h2>
			Thanks for your contribution to <a href={dataPackage.projectUrl} rel="external" target="_blank"
				>{dataPackage.name}</a
			>
		</h2>
		<p>Merge Request : <a href={mergeRequestUrl} rel="external" target="_blank">{mergeRequestUrl}</a></p>
	{/if}
{:else}
	<MultilineLoadIndicator />
{/if}
